#ifndef FileTimeZone_H
#define FileTimeZone_H

#include "TimeZone.h"
#include "privates_p.h"
#include <QtGui>

class FileTimeZone : public TimeZone {
public:
    FileTimeZone()
        : TimeZone(new FileTimeZonePrivate())
    {
        d = static_cast<FileTimeZonePrivate*> (TimeZone::d);
    }

    FileTimeZone(const FileTimeZone &other)
        : TimeZone(other.d),
        d(other.d)
    {
    }

    FileTimeZone(const TimeZone &other)
        : TimeZone(other.d)
    {
        d = dynamic_cast<FileTimeZonePrivate*> (other.d);
    }

    ~FileTimeZone() {
        d =0; // refcount fixed in superclass.
    }

    bool baz() const { return d->baz; }
    void setBaz(bool on) { d->baz = on; }

private:
    FileTimeZonePrivate * d;
};

#endif
