#ifndef TimeZone_H
#define TimeZone_H

#include "privates_p.h"
#include <QtGui>

class TimeZone {
public:
    TimeZone(const TimeZone &orig)
        : d( orig.d)
    {
        d->refCount++;
    }
bool operator==(const TimeZone &other) {
        return other.d == d;
    }
    TimeZone& operator=(const TimeZone &other) {
        if(other.d == d)
            return *this;
        if(--d->refCount == 0)
            delete d;
        d = other.d;
        d->refCount++;
        return *this;
    }

    ~TimeZone() {
        if(d && --d->refCount == 0)
            delete d;
        d =0;
    }

    bool foo() const { return d->foo; }

    bool isValid() const { return d; }

protected:
    TimeZone(TimeZonePrivate *priv) : d(priv) // I assume that this class is never instantiated, only its derivitives are.
    {
        if(d)
            d->refCount++;
    }
private:
    TimeZonePrivate * d;
    friend class FileTimeZone; // alternatively, you can use the Q_D macro for this.
};

#endif
